//
// C++ Implementation: %{MODULE}
//
// Description:
//
//
// Author: %{AUTHOR} <%{EMAIL}>, (C) %{YEAR}
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "defaults.h"
#include "cdemuxdevice.h"
#include "sectionreceiver.h"

#include <iostream>
#include <linux/dvb/dmx.h>
#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <errno.h>
#include <sys/ioctl.h>
#include <stdlib.h>
#include <string.h>

using namespace std;

cDemuxDevice::cDemuxDevice(int _adapter, int _demux, int _pid)
{
    adapter  = _adapter;
    demux    = _demux;
    pid      = _pid;
    demux_fd = -1;
}

cDemuxDevice::~cDemuxDevice()
{
	Close();
}


bool cDemuxDevice::Open()
{
	struct dmx_sct_filter_params sctFilterParams;
	char demuxdevice[100];
	snprintf(demuxdevice, 100, "/dev/dvb/adapter%d/demux%d", adapter, demux);

	printf("DEMUX : %s\n",demuxdevice);
	if ((demux_fd = open(demuxdevice, O_RDWR)) < 0) {
		perror("open demux DEVICE:");
		return false;
	}
	memset(&sctFilterParams, 0, sizeof(sctFilterParams));

	sctFilterParams.pid = pid;
	sctFilterParams.flags = DMX_IMMEDIATE_START | DMX_CHECK_CRC;
	sctFilterParams.filter.filter[0] = 0x3e;
	sctFilterParams.filter.mask[0] = 0xff;

	// Size of read packets 1456
	const int bufsize = 1456*2048;

	if (ioctl(demux_fd, DMX_SET_BUFFER_SIZE, bufsize)<0) {
		perror("DMX SET BUFFER SIZE");
		close(demux_fd);
		demux_fd=-1;
		return false;
	}
	
	if (ioctl(demux_fd, DMX_SET_FILTER, &sctFilterParams) < 0) {
		perror("fd_sect - DMX_SET_FILTER:");
		close(demux_fd);
		demux_fd=-1;
		return false;
	}
	return true;
}

void cDemuxDevice::Close()
{
	if (demux_fd!=-1)
	{
		close(demux_fd);
		demux_fd=-1;
	}
}

void cDemuxDevice::Action()
{
	__u8 sectbuffer[4096];
	int size;
	Open();
	cerr << "Start receiving from PID " << pid << endl;
	while (1) {
		int size=read(demux_fd, sectbuffer, sizeof(sectbuffer));
		if (size>0) {
			receiveSection(sectbuffer, size);
		} else {
			usleep(100);
		}
	}
	Close();
}
