//
// C++ Implementation: %{MODULE}
//
// Description:
//
//
// Author: %{AUTHOR} <%{EMAIL}>, (C) %{YEAR}
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "defaults.h"
#include "cdemuxfile.h"
#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <errno.h>
#include <iostream>

using namespace std;
cDemuxFile::cDemuxFile(char *_fname)
{
	fname=_fname;
	input_fd=-1;
}

cDemuxFile::~cDemuxFile()
{
	Close();
}

bool cDemuxFile::Open()
{
	if ((input_fd = open(fname, O_RDWR)) < 0) {
		perror("open input file");
		return false;
	}
	return true;
}

void cDemuxFile::Close()
{
	if (input_fd!=-1)
	{
		close(input_fd);
		input_fd=-1;
	}
}

void cDemuxFile::Action()
{
	__u8 sectbuffer[4096];
	int size;
	Open();
	cerr << "Start receiving from " << fname << endl;
	while (1) {
		int tmp;
		tmp=read(input_fd, &size, sizeof(size));
		if (tmp!=sizeof(size)) {
			if (tmp==0) {
				cerr << "End of file reached" << endl;
				return;
			}
			cerr << "Error: read from file" << endl;
			want_exit=true;
			return;
		}
		if (sizeof(sectbuffer)<size) {
			cerr << "error: Buffer to small" << endl;
			want_exit=true;
			return;
		}
		tmp=read(input_fd, sectbuffer, size);
		if (tmp!=size) {
			cerr << "error: Read from file. Only got " << tmp << " of " << size << " bytes" << endl;
			want_exit=true;
			return;
		}
		if (size>0) {
			receiveSection(sectbuffer, size);
			usleep(40);
		}
	}
	Close();
}

