//
// C++ Interface: %{MODULE}
//
// Description: 
//
//
// Author: %{AUTHOR} <%{EMAIL}>, (C) %{YEAR}
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef CSECTION_H
#define CSECTION_H

#include <netinet/ip.h>
#include <netinet/udp.h>
#include <netinet/if_ether.h>
#include "util.h"

#define DSMCC_SECTION_MPE 0x3E


struct SECTION_HEADER_BIN {
	__u8	table_id;
	__u8	length2;
	__u8	length1;
	__u8	mac6;
	__u8	mac5;

	__u8	space1;
	__u8	section_number;
	__u8	last_section_number;

	__u8	mac4;
	__u8	mac3;
	__u8	mac2;
	__u8	mac1;
};


class Section : virtual public Parsable {
   
public:
   Section(int length);
   virtual ~Section();
   
   virtual void Parse(RawData Data, int &off);

protected:
   void ParseIP(RawData Data, int &off);
   void ParseUDP(RawData Data, int &off);

public:
   static bool testMAC(__u8 mac[], __u8 mask[], __u8 mac_test[]);

public:
   bool testMACdest(__u8 mask[], __u8 mac[]);
   bool valid; //CRC and content
   int Length;

   iphdr *m_iphdr;
   udphdr *m_udphdr;
   ethhdr *m_ethhdr;
   int m_datalen;

   char table_id; //always 0x3B
   unsigned char flags[2];
   unsigned short table_id_extension;

   enum Type { NONE, IP, UDP, TCP } typ;

   /*
   *  unsigned int section_syntax_indicator : 1; UKProfile - always 1
   *  unsigned int private_indicator : 1;  UKProfile - hence always 0
   *  unsigned int reserved : 2;  always 11b
   *  unsigned int dsmcc_section_length : 12;
   **/
   unsigned char flags2;
   /*
   *  unsigned int reserved : 2;  always 11b
   *  unsigned int version_number : 5;  00000b
   *  unsigned int current_next_indicator : 1  1b
   * */
   unsigned long crc;

private:
   ethhdr eth;
   
};

#endif // __section_h_
